/*
  $Id: oiladt2a.h,v 1.13 90/09/26 14:28:50 swain Exp $
Copyright, 1989, The Regents of the University of Colorado
*/

extern tOilArgSig OilNewArgSig();	/* a zero length signature */

extern tOilArgSig OilAddArgSig();	/* ( arg, sig )
		tOilType arg;
		tOilArgSig sig; */



extern tOilSetSig OilNewSetSig() ; /* no args */
extern tOilSetSig OilAddSetSig();	/* ( arg, sig )
		tOilTypeSet arg;
		tOilSetSig sig; */



extern tOilOp OilNewOp();	/* ( id, sig, cost )
        oilName id;
	int cost;
	tOilArgSig sig;    */

extern tOilOp  OilErrorOp();

extern BOOL OilAddIdentification();  /* ( id, op )
	tOilOp id
	tOilOp op; */



extern tOilType OilNewType();  /* ( id ) */

extern tOilType OilErrorType();

/* define a new type of class 'c' with element type 'as' with name 'id' */
extern tOilType OilNewTypeInClass();  /* ( c, as, id )
	tOilClass c;
	tOilArgSig as;
	oilName id */



/* validate type t1 is coercible to t2 */
extern BOOL OilIsCoercibleTo();  /* ( t1, t2 ) tOilType t1, t2;*/

/* validate that type 't2' is in the type set 's1'	*/
extern BOOL OilSetIncludes();  /* ( s1, t2 ) tOilTypeSet s1; tOilType t2;*/

/* add a new type to the set of possible result types*/
extern tOilTypeSet OilAddResultType();  /* ( t, set,cost )
	tOilType t; tOilTypeSet set; int cost; */



/* Check the sets of possible actual argument types to see if they might
	be coerced to the corresponding formal type 
extern BOOL OilCanIdSigs();  /* ( src, dest )
	tOilSetSig src;
	tOilArgSig dest; */



/* check for valid coercion*/
extern BOOL OilisValidCS();  /* ( ccs ) tOilCoercionSeq ccs; */

/* check for valid operator*/
extern BOOL OilisValidOp();  /* ( op ) tOilOp op; */

/* return coercion sequence for coercing 't1' to 't2'*/
extern tOilCoercionSeq OilCoerce();  /* ( t1, t2 )
	tOilType t1, t2;
  */

extern BOOL OilEmptyCS(); /* ( cs )
        tOilCoercionSeq cs;
  */

extern tOilOp  OilHeadCS(); /* ( cs )
        tOilCoercionSeq cs;
  */

extern tOilCoercionSeq  OilTailCS(); /* ( cs )
    tOilCoercionSeq cs;
  */

extern tOilCoercionSeq  OilErrorCS();

extern BOOL OilAddCoercion(); /* ( cop )
	tOilOp cop;
  */




/* find all possible result types which might be indicated by 'ind'
	with arguments 'setsig' */
extern tOilTypeSet OilIdResultSet();  /* ( ind, setsig )
	tOilOpIndication ind;
	tOilSetSig setsig; */

/* find the minimum operator cost which might be indicated by 'ind'
	with arguments 'setsig' and result type 'rt' */
extern tOilOp OilIdOpTSn();  /* ( ind, setsig, rt )
	tOilType rt;
	tOilOpIndication ind;
	tOilSetSig setsig; */

extern tOilTypeSet OilTypeToSet();  /* ( t ) tOilType t; */

extern tOilType OilBalance();  /* ( ts1, ts2 )
        tOilTypeSet ts1, ts2; */
/* 
#define OilSelectTypeFromTS(ts) OilBalance(ts,ts)

extern int OilMinimumCoercionSeq();  /* ( ts1, ts2, cost )
	tOilTypeSet ts1, ts2;
	int cost;
extern int OilMinimumCoercionCost();  /* ( ts, t, cost )
	tOilTypeSet ts;
	tOilType t;
	int cost;
  */



extern tOilClass OilNewClass();  /* ( id, argNum )
	oilName id;
	int argNum;
  */

extern tOilClassArgSig OilNewClassSigArg(); /* returns nil */

extern tOilClassArgSig OilAddClassSigArg();  /* ( td, st, pi, cs )
	tOilClassSigArgDesc td;
	tOilType st;
	int pi;
	tOilClassArgSig cs;
  */

extern tOilClassOp OilAddClassOp();  /* ( id, sig, cost, c )
        oilName id;
        int cost;
        tOilClassArgSig sig;
        tOilClass c;
  */

extern BOOL OilAddClassOpId();  /* ( ind, op )
	tOilOpIndication ind;
        tOilClassOp op;
  */

extern BOOL OilAddClassCoercion();  /* ( op )
        tOilClassOp op;
  */

/* Get type of argument #n of operator 'op' */
extern tOilType OilGetArgType();  /* ( op, n )
	tOilOp op; int n;
  */

	/* the end of oiladt2a.h */
